/* test.c autoXml generated file */

#include "common.h"
#include "xap.h"
#include "test.h"

void *testStartHandler(struct xap *xp, char *name, char **atts);
/* Called by expat with start tag.  Does most of the parsing work. */

void testEndHandler(struct xap *xp, char *name);
/* Called by expat with end tag.  Checks all required children are loaded. */


void testDasdsnSave(struct testDasdsn *obj, int indent, FILE *f)
/* Save testDasdsn to file. */
{
struct testDsn *testDsn;
if (obj == NULL) return;
xapIndent(indent, f);
fprintf(f, "<DASDSN>");
fprintf(f, "\n");
for (testDsn = obj->testDsn; testDsn != NULL; testDsn = testDsn->next)
   testDsnSave(testDsn, indent+2, f);
xapIndent(indent, f);
fprintf(f, "</DASDSN>\n");
}

struct testDasdsn *testDasdsnLoad(char *fileName)
/* Load testDasdsn from file. */
{
struct testDasdsn *obj;
xapParseAny(fileName, "DASDSN", testStartHandler, testEndHandler, NULL, &obj);
return obj;
}

void testDsnSave(struct testDsn *obj, int indent, FILE *f)
/* Save testDsn to file. */
{
if (obj == NULL) return;
xapIndent(indent, f);
fprintf(f, "<DSN>");
fprintf(f, "\n");
testSourceSave(obj->testSource, indent+2, f);
testDescriptionSave(obj->testDescription, indent+2, f);
testMapmasterSave(obj->testMapmaster, indent+2, f);
xapIndent(indent, f);
fprintf(f, "</DSN>\n");
}

struct testDsn *testDsnLoad(char *fileName)
/* Load testDsn from file. */
{
struct testDsn *obj;
xapParseAny(fileName, "DSN", testStartHandler, testEndHandler, NULL, &obj);
return obj;
}

void testSourceSave(struct testSource *obj, int indent, FILE *f)
/* Save testSource to file. */
{
if (obj == NULL) return;
xapIndent(indent, f);
fprintf(f, "<SOURCE");
fprintf(f, " id=\"%s\"", obj->id);
if (obj->version != NULL)
    fprintf(f, " version=\"%s\"", obj->version);
fprintf(f, ">");
fprintf(f, "%s", obj->text);
fprintf(f, "</SOURCE>\n");
}

struct testSource *testSourceLoad(char *fileName)
/* Load testSource from file. */
{
struct testSource *obj;
xapParseAny(fileName, "SOURCE", testStartHandler, testEndHandler, NULL, &obj);
return obj;
}

void testDescriptionSave(struct testDescription *obj, int indent, FILE *f)
/* Save testDescription to file. */
{
if (obj == NULL) return;
xapIndent(indent, f);
fprintf(f, "<DESCRIPTION");
if (obj->href != NULL)
    fprintf(f, " href=\"%s\"", obj->href);
fprintf(f, ">");
fprintf(f, "%s", obj->text);
fprintf(f, "</DESCRIPTION>\n");
}

struct testDescription *testDescriptionLoad(char *fileName)
/* Load testDescription from file. */
{
struct testDescription *obj;
xapParseAny(fileName, "DESCRIPTION", testStartHandler, testEndHandler, NULL, &obj);
return obj;
}

void testMapmasterSave(struct testMapmaster *obj, int indent, FILE *f)
/* Save testMapmaster to file. */
{
if (obj == NULL) return;
xapIndent(indent, f);
fprintf(f, "<MAPMASTER>");
fprintf(f, "%s", obj->text);
fprintf(f, "</MAPMASTER>\n");
}

struct testMapmaster *testMapmasterLoad(char *fileName)
/* Load testMapmaster from file. */
{
struct testMapmaster *obj;
xapParseAny(fileName, "MAPMASTER", testStartHandler, testEndHandler, NULL, &obj);
return obj;
}

void *testStartHandler(struct xap *xp, char *name, char **atts)
/* Called by expat with start tag.  Does most of the parsing work. */
{
struct xapStack *st = xp->stack+1;
int depth = xp->stackDepth;
int i;

if (sameString(name, "DASDSN"))
    {
    struct testDasdsn *obj;
    AllocVar(obj);
    return obj;
    }
else if (sameString(name, "DSN"))
    {
    struct testDsn *obj;
    AllocVar(obj);
    if (depth > 1)
        {
        if  (sameString(st->elName, "DASDSN"))
            {
            struct testDasdsn *parent = st->object;
            slAddHead(&parent->testDsn, obj);
            }
        else
            xapError(xp, "%s misplaced", name);
        }
    return obj;
    }
else if (sameString(name, "SOURCE"))
    {
    struct testSource *obj;
    AllocVar(obj);
    for (i=0; atts[i] != NULL; i += 2)
        {
        char *name = atts[i], *val = atts[i+1];
        if  (sameString(name, "id"))
            obj->id = cloneString(val);
        else if (sameString(name, "version"))
            obj->version = cloneString(val);
        else
            xapError(xp, "Unknown attribute %s", name);
        }
    if (obj->id == NULL)
        xapError(xp, "missing id");
    if (depth > 1)
        {
        if  (sameString(st->elName, "DSN"))
            {
            struct testDsn *parent = st->object;
            slAddHead(&parent->testSource, obj);
            }
        else
            xapError(xp, "%s misplaced", name);
        }
    return obj;
    }
else if (sameString(name, "DESCRIPTION"))
    {
    struct testDescription *obj;
    AllocVar(obj);
    for (i=0; atts[i] != NULL; i += 2)
        {
        char *name = atts[i], *val = atts[i+1];
        if  (sameString(name, "href"))
            obj->href = cloneString(val);
        else
            xapError(xp, "Unknown attribute %s", name);
        }
    if (depth > 1)
        {
        if  (sameString(st->elName, "DSN"))
            {
            struct testDsn *parent = st->object;
            slAddHead(&parent->testDescription, obj);
            }
        else
            xapError(xp, "%s misplaced", name);
        }
    return obj;
    }
else if (sameString(name, "MAPMASTER"))
    {
    struct testMapmaster *obj;
    AllocVar(obj);
    if (depth > 1)
        {
        if  (sameString(st->elName, "DSN"))
            {
            struct testDsn *parent = st->object;
            slAddHead(&parent->testMapmaster, obj);
            }
        else
            xapError(xp, "%s misplaced", name);
        }
    return obj;
    }
else
    {
    xapError(xp, "Unknown element %s", name);
    return NULL;
    }
}

void testEndHandler(struct xap *xp, char *name)
/* Called by expat with end tag.  Checks all required children are loaded. */
{
struct xapStack *stack = xp->stack;
if (sameString(name, "DASDSN"))
    {
    struct testDasdsn *obj = stack->object;
    if (obj->testDsn == NULL)
        xapError(xp, "Missing DSN");
    slReverse(&obj->testDsn);
    }
else if (sameString(name, "DSN"))
    {
    struct testDsn *obj = stack->object;
    if (obj->testSource == NULL)
        xapError(xp, "Missing SOURCE");
    if (obj->testSource->next != NULL)
        xapError(xp, "Multiple SOURCE");
    if (obj->testDescription != NULL && obj->testDescription->next != NULL)
        xapError(xp, "Multiple DESCRIPTION");
    if (obj->testMapmaster == NULL)
        xapError(xp, "Missing MAPMASTER");
    if (obj->testMapmaster->next != NULL)
        xapError(xp, "Multiple MAPMASTER");
    }
else if (sameString(name, "SOURCE"))
    {
    struct testSource *obj = stack->object;
    obj->text = cloneString(stack->text->string);
    }
else if (sameString(name, "DESCRIPTION"))
    {
    struct testDescription *obj = stack->object;
    obj->text = cloneString(stack->text->string);
    }
else if (sameString(name, "MAPMASTER"))
    {
    struct testMapmaster *obj = stack->object;
    obj->text = cloneString(stack->text->string);
    }
}

int main(int argc, char *argv[])
/* Test driver for test routines */
{
struct testDasdsn *obj;
if (argc != 2)
    errAbort("Please run again with a xml filename.");obj = testDasdsnLoad(argv[1]);
testDasdsnSave(obj, 0, stdout);
return 0;
}
